#include <stdlib.h>
#include <stdio.h>

#define population 100
#define column 10
#define row 10

struct node {
	int unit;
	int x, oldX;
	int y, oldY;
	int nature;
	struct node * parent;
	struct node * enfant;
} array[population] , *matrix[column][row] , *naitre , *etre , *fate;

struct {
	struct node * ame[population];
	int premier;
	int dernier;
} styx;

//==============================================================================================
//==============================================================================================
//==============================================================================================
//==============================================================================================

struct node * birth(void)
{
	struct node * newborn;
	newborn = (styx.ame[styx.premier]);
	styx.premier = styx.premier + 1;
	newborn->parent = fate;
	fate->enfant = newborn;
	newborn->enfant = NULL;
	fate = newborn;
	return newborn;
}

//==============================================================================================
//==============================================================================================
//==============================================================================================
//==============================================================================================

int kill(struct node *mort)
{
	if ((mort->enfant == mort)&&(mort->parent == mort))
	{	return 0;		}
/*
	if (matrix[mort->x][mort->y] == mort)
	{
		(matrix[mort->x][mort->y]) = NULL;
	}
*/
	if (mort->parent != NULL)
	{
		mort->parent->enfant = mort->enfant;
	} else { naitre = mort->enfant; }

	if (mort->enfant != NULL)
	{
		mort->enfant->parent = mort->parent;
	} else { fate = mort->parent; }

	if (styx.dernier == 0)
	{	styx.dernier = 1;	}
	if (styx.premier == 0)
	{	styx.premier = 1;	}

	styx.ame[styx.dernier] = mort;
	if (styx.dernier < population)
	{
	styx.dernier = styx.dernier + 1;
	}

	mort->parent = mort;
	mort->enfant = mort;

	return 0;
}

//==============================================================================================
//==============================================================================================
//==============================================================================================
//==============================================================================================

void existance(void)
{
	etre = naitre;
	while (etre->enfant != 0)
	{
		if ((etre->x != etre->oldX)&&(etre->y != etre->oldY))
		{
			matrix[etre->oldX][etre->oldY] = NULL;
			etre->oldX = etre->x;
			etre->oldY = etre->y;
		}
		if ((matrix[etre->x][etre->y] != NULL)&&(matrix[etre->x][etre->y] != etre))
		{		kill(matrix[etre->x][etre->y]);
		}	
				matrix[etre->x][etre->y] = (etre);
		

		etre = etre->enfant;
	}
}

//==============================================================================================
//==============================================================================================
//==============================================================================================
//==============================================================================================

void in_the_begining(void)
{
	int unit;
	for (unit = 1; unit < population; unit = unit+1)
	{

		if (unit != 1)
		{
			array[unit].parent = &(array[unit-1]);
		} else {
			array[unit].parent = NULL;
			naitre = &(array[unit]);
			etre = naitre;
		}
		if (unit != 99)
		{
			array[unit].enfant = &(array[unit+1]);
		} else {
			array[unit].enfant = NULL;
		}
		
		array[unit].unit = unit;
	}
}

//==============================================================================================
//==============================================================================================
//==============================================================================================
//==============================================================================================

int main(void)
{
	int unit;


	printf("randomize the array content\n");
	for (unit = 1; unit < population; unit = unit+1)
	{
		array[unit].x = rand()%10;
		array[unit].y = rand()%10;
		array[unit].nature = rand();
	}

	printf("genealogy of the array\n");
	in_the_begining();
	printf("materialisation of the matrix\n");
	existance();

	printf("kill array[98] to see if it will disapear\n\n");
	kill(&(array[98]));
	printf("kill array[1] to see what happen\n\n");
	kill(&(array[1]));
	printf("kill array[99] to see what happen\n\n");
	kill(&(array[99]));
	printf("kill array[99] again\n\n");
	kill(&(array[99]));

	printf("give birth to a new node\n");
	struct node * newborn = birth();
	printf("and check for existence\n\n");
	existance();

	etre = naitre;
	while (etre->enfant != NULL)
	{
		printf("pointer etre->parent = %d\n",etre->parent);
		printf("etre->unit = %d | ",etre->unit);
		printf("etre->x = %d | ",etre->x);
		printf("etre->y = %d\n",etre->y);
		printf("etre->nature = %d\n",etre->nature);
		printf("matrix[%d][%d].nature = %d\n",etre->x,etre->y,(*matrix[etre->x][etre->y]).nature);
		printf("pointer etre = %d\n",(etre));
		printf("pointer matrix[%d][%d] = %d\n",etre->x,etre->y,matrix[etre->x][etre->y]);
		printf("pointer etre->enfant = %d\n",etre->enfant);
		printf("now etre = etre->enfant if that last is not zero\n\n");

		etre = etre->enfant;
	}
		printf("pointer etre->parent = %d\n",etre->parent);
		printf("etre->unit = %d | ",etre->unit);
		printf("etre->x = %d | ",etre->x);
		printf("etre->y = %d\n",etre->y);
		printf("etre->nature = %d\n",etre->nature);
		printf("matrix[%d][%d].nature = %d\n",etre->x,etre->y,(*matrix[etre->x][etre->y]).nature);
		printf("pointer etre = %d\n",(etre));
		printf("pointer matrix[%d][%d] = %d\n",etre->x,etre->y,matrix[etre->x][etre->y]);
		printf("pointer etre->enfant = %d\n",etre->enfant);
		printf("it seam that last etre->enfant is ZERO\n\n");

	printf("show all node.unit that waitin in the styx\n");
	for (unit = styx.premier; unit < styx.dernier; unit = unit + 1)
	{
		printf(" %d ",styx.ame[unit]->unit);
	}
	printf("\n");
	return 0;
}
